<dx-data-grid class="gridContainer box-shadow" #gridContract [columnAutoWidth]='true' [allowColumnResizing]='true'
  [allowColumnReordering]='true' [hoverStateEnabled]="true" [showColumnLines]='ui.showColumnLines' [showRowLines]='ui.showRowLines'
  [dataSource]='dsContracts' (onToolbarPreparing)='toolbarPreparing($event)' [height]='ui.fullHeight'>
  <dxo-export [enabled]='true' [enabled]='true' fileName='contracts'></dxo-export>
  <dxo-header-filter [visible]='true'></dxo-header-filter>
  <dxo-group-panel [visible]='true'></dxo-group-panel>
  <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
  <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='true'></dxo-scrolling>
  <dxo-search-panel [visible]='true'></dxo-search-panel>
  <dxo-state-storing [enabled]="true" type="localStorage" storageKey="qhseContracts"></dxo-state-storing>
  <dxo-filter-row [visible]='true'></dxo-filter-row>
  <dxo-column-chooser [enabled]="true" mode='dragAndDrop'></dxo-column-chooser>
  <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
  <dxo-master-detail [enabled]='true' template='details'></dxo-master-detail>

  <dxi-column [caption]='ds.lg.format("CONTRACT NO")' dataField='no' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
  <dxi-column [caption]='ds.lg.format("CONTRACTOR")' dataField='fromId' dataType='string' width='170'>
    <dxo-lookup [dataSource]='dspCtr' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column [caption]='ds.lg.format("CONTRACTEE")' dataField='toId' dataType='string' width='170'>
    <dxo-lookup [dataSource]='dspCtr' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column [caption]='ds.lg.format("OBJECT CONTRACT")' dataField='contractObjective' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
  <dxi-column [caption]='ds.lg.format("START DATE")' dataField='startDate' dataType='date' width='170' calculateSortValue='startDate'
    [calculateCellValue]='ds.getDate'></dxi-column>
  <dxi-column [caption]='ds.lg.format("END DATE")' dataField='endDate' dataType='date' width='170' calculateSortValue='endDate'
    [calculateCellValue]='ds.getDate'></dxi-column>
  <dxi-column [caption]='ds.lg.format("VALID")' dataField='isValid' dataType='number' width='110' [allowHeaderFiltering]='false'>
    <dxo-lookup [dataSource]='dsBoolean' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column [caption]='ds.lg.format("CONTRACT VALUE")' dataField='contractValue' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
  <dxi-column type="buttons" fixedPosition='left' width='110' [fixed]='true' [allowResizing]='false'
    [showInColumnChooser]='false'>
    <dxi-button hint='Editează' icon="edit" [onClick]="onEditContractsClick"></dxi-button>
    <dxi-button hint='Șterge' icon='trash' [onClick]="onDeleteContractsClick"></dxi-button>
  </dxi-column>

  <div *dxTemplate='let data of "details"'>
    <app-file-upload [gridData]='data'></app-file-upload>
  </div>
</dx-data-grid>

<dx-popup [(visible)]='edit.isContractVisible' [minWidth]='ui.minWidthPopup' width='auto' maxWidth='90vw' (onShown)='ui.onPopupShown($event)'
  (onHidden)='ui.onPopupHidden($event)' height='auto' title='Contracte'>
  <div *dxTemplate="let data of 'content'">
    <dx-scroll-view [height]='ui.scrollHeight' width="auto" direction="both">
      <app-edit-contract [contractData]='edit.contractModel'></app-edit-contract>
    </dx-scroll-view>
  </div>
  <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează', icon:'save', type: 'normal', onClick: onSaveContract, validationGroup: edit.contractValidation }">
  </dxi-toolbar-item>
</dx-popup>